SystemOrganization addCategory: #PluggableTextMorphWithLimits!

PluggableTextMorph subclass: #PluggableTextMorphWithLimits
	instanceVariableNames: 'warningLimit alertLimit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PluggableTextMorphWithLimits'!

!PluggableTextMorphWithLimits classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:29'!
DefaultWarningLimit: anInteger

	DefaultWarningLimit := anInteger! !

!PluggableTextMorphWithLimits classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:38'!
defaultWarningLimit

	^ DefaultWarningLimit ifNil: [ DefaultWarningLimit := 350 ]! !

!PluggableTextMorphWithLimits classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:29'!
defaultWarningLimit: anInteger
	" self defaultWarningLimit:nil "

	DefaultWarningLimit := anInteger! !

!PluggableTextMorphWithLimits classSide methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:37'!
resetDefaultWarningLimit
	" self resetDefaultWarningLimit "

	self defaultWarningLimit: nil! !

!PluggableTextMorphWithLimits classSide methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/3/2011 14:43'!
textSizeOf: aText

	| result count ignoredCharacters |
	result := 0.
	count := true.
	ignoredCharacters := { Character space. Character tab. Character cr. $.. $;. $:. $'}.
	aText do: [:char |
		(char = $")
			ifTrue: [ count := count not ]
			ifFalse: [
				((ignoredCharacters includes: char) not and: [ count ])
					ifTrue: [ result := result + 1 ]]].
	^ result.! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 12:34'!
alertLimit

		^ alertLimit ifNil: [ alertLimit := 2 * (self warningLimit) ]! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 12:34'!
alertLimit: anObject
	
		alertLimit := anObject! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 5/3/2011 14:54'!
basicColor

	^ extension
		ifNil: [ color]
		ifNotNil: [ extension fillStyle ifNil: [ color ]].! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 5/3/2011 15:36'!
buildRectFrom: rect

	| top bottom right left hasVScroolbar |
	hasVScroolbar := 0.
	self vIsScrollbarShowing ifTrue: [ hasVScroolbar := 1 ].
	top := (rect bottom - StandardFonts defaultFont height - 4).
	bottom := rect bottom.
	right := rect right.
	left := right - (( self textSize printString size + 1 + hasVScroolbar ) * (StandardFonts defaultFont widthOf: $2)).
	^ (left@top corner: right@bottom)! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 5/4/2011 10:46'!
drawOn: aCanvas

	| rect top bottom left right stringColor size |
	super drawOn: aCanvas.
	size := self textSize.
	rect := self buildRectFrom: self bounds.
	
	stringColor := self stringColor.
	
	self warningLimit negative
		ifFalse: [ aCanvas drawString: size printString in: rect font: TextStyle defaultFont color: stringColor ].! !

!PluggableTextMorphWithLimits methodsFor: 'drawing' stamp: 'BenjaminVanRyseghem 5/3/2011 15:01'!
fillStyle
	"Return the current fillStyle of the receiver."
	
	| basicColor |
	basicColor := self basicColor.
	
	self warningLimit negative ifTrue: [ ^ basicColor ].
	
	textMorph ifNotNil: [ | size |
		size := self textSize.
		( size >= self warningLimit )
			ifTrue: [ | returnedColor length ratio limitColor |
				( size >= self alertLimit)
					ifTrue: [
						ratio := (size - self alertLimit) / 150.
						limitColor := Color orange.
						basicColor := Color yellow ]
					ifFalse: [
						length := self alertLimit - self warningLimit.
						ratio := (size - self warningLimit) / length.
						limitColor := Color yellow ].
					returnedColor := limitColor mixed: ratio with: basicColor.
					^ returnedColor ]].
	^ basicColor
! !

!PluggableTextMorphWithLimits methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/3/2011 15:43'!
stringColor
	
	| size |
	size := self textSize.
	self warningLimit negative ifTrue: [ ^ Color black ].
	^ size >= self warningLimit
			ifTrue: [
				size >= self alertLimit
					ifTrue: [ Color red ]
					ifFalse: [ Color orange ]]
			ifFalse: [ Color black ].! !

!PluggableTextMorphWithLimits methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/3/2011 14:41'!
textSize

	^ self class textSizeOf: self text! !

!PluggableTextMorphWithLimits methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/3/2011 14:40'!
textSizeOf: aText

	| result count ignoredCharacters |
	result := 0.
	count := true.
	ignoredCharacters := { Character space. Character tab. Character cr. $.. $;. $:. $'}.
	aText do: [:char |
		(char = $" or: [ char = $| ])
			ifTrue: [ count := count not ]
			ifFalse: [
				((ignoredCharacters includes: char) not and: [ count ])
					ifTrue: [ result := result + 1 ]]].
	^ result.! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 12:35'!
warningLimit

		^ warningLimit ifNil: [ warningLimit := self class defaultWarningLimit ]! !

!PluggableTextMorphWithLimits methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 12:34'!
warningLimit: anObject
	
		warningLimit := anObject! !
